/*
===========================================================
     ATTENTION!!!!

     This file is in the Public Domain.
     Provided by the Internet Movie Project (www.imp.org)
===========================================================

 File        : shot02.inc
 Project     : IRTC Entry for "The end of..." round
 cvs module  : theendof
 POV Version : 3.5
 Description : Opening Shot
 Date        : 20031108
 Created by  : Sascha Ledinsky
 Modified by : Dennis Borree 20031123 (trulayne - at - new - dot - rr - dot - com) 
 Copyright   : Released into the Public Domain
 
===========================================================
*/

//
//   14 seconds
//

/*
#include "include/colors.inc"
#include "include/textures.inc"
#include "include/shapes.inc"
#include "include/metals.inc"
#include "include/glass.inc"
#include "include/woods.inc"
*/

#declare camera_location = <0,0.5,-5>;

#declare clock_room=clock02;

#declare door_open = 0;

#include "include/colors.inc"
#include "include/woods.inc"
#include "scenes/room/room.inc"
#include "scenes/room/sythe.inc"
#include "include/transforms.inc"
#include "scenes/room/skeleton_hand_presets.inc"
#include "scenes/room/skeleton_hand.inc"
#include "scenes/room/reaper.inc"
#include "scenes/room/spider.inc"


camera {
	right <16/9,0,0>
	up <0,1,0>
	location camera_location
	//look_at <-1.2,1.6,0> => <0,0.8,0>
	//look_at <-0.2*(6-clock02),0.8+0.8/6*(6-clock02),0>
	look_at <0,0.8,0>
	//angle 2+48/6*clock02 // 5 => 50
	angle 50
}


//scythe

object {sythe  rotate x*-157 rotate z*15 translate <1.6,1.39,0>}

/*
/// shadow of death ///////////////////////////

#include "scenes/splines/splines2D.inc"

#local death_outline_1 = array[12 * 5] {
	-1.0,	 6.0,	0.0,	0.0,	 0.0,
	 0.3,	 6.1,	1.0,	1.0,	 0.0,
	 1.3,	 5.0,	1.0,	1.0,	 0.0,
	 1.2,	 3.0,	1.0,	1.0,	 0.0,
	 1.3,	 2.5,	1.0,	1.0,	 0.0,
	 2.6,	 1.2,	1.0,	1.0,	 0.0,
	 4.0,	-24.5,	0.0,	0.0,	 0.0,
	-2.5,	-24.5,	0.0,	0.0,	 0.0,
	-2.0,	 0.9,	1.0,	1.0,	 0.0,
	-0.8,	 2.0,	1.0,	1.0,	 0.0,
	-0.8,	 2.7,	1.0,	1.0,	 0.0,
	-1.3,	 4.0,	1.0,	1.0,	 0.0,
}

#local death_outline_2 = array[12 * 5] {
	-1.0,	 6.1,	0.0,	0.0,	 0.0,
	 0.3,	 6.1,	1.0,	1.0,	 0.0,
	 1.5,	 5.0,	1.0,	1.0,	 0.0,
	 1.2,	 3.0,	1.0,	1.0,	 0.0,
	 1.4,	 2.5,	1.0,	1.0,	 0.0,
	 2.8,	 1.2,	1.0,	1.0,	 0.0,
	 5.0,	-24.5,	0.0,	0.0,	 0.0,
	-2.5,	-24.5,	0.0,	0.0,	 0.0,
	-2.0,	 0.9,	1.0,	1.0,	 0.0,
	-0.8,	 2.0,	1.0,	1.0,	 0.0,
	-0.8,	 2.7,	1.0,	1.0,	 0.0,
	-1.3,	 4.0,	1.0,	1.0,	 0.0,
}

#local scythe_outline_1 = array[13 * 5] {
	-0.3,	 1.6,	0.0,	0.0,	 0.0,
	 2.7,	 4.2,	0.0,	0.0,	 0.0,
	 2.3,	 4.3,	0.0,	0.0,	 0.0,
	 //1.2,	 3.0,	0.0,	0.0,	 0.0,
	 3.2,	 5.0,	0.0,	0.0,	 0.0,
	 3.3,	 4.6,	0.0,	0.0,	 0.0,
	 3.6,	 4.9,	0.0,	0.0,	 0.0,
	 4.0,	 4.5,	0.0,	0.0,	 0.0,
	 3.6,	 4.3,	0.0,	0.0,	 15.0,
	 4.4,	 3.0,	1.0,	1.0,	 0.0,
	 4.5,	 1.0,	0.0,	0.0,	 0.0,
	 4.0,	 2.8,	1.0,	1.0,	 0.0,
	 3.2,	 3.9,	0.0,	0.0,	 0.0,
	 0.0,	 1.2,	0.0,	0.0,	 0.0,
}

#local cycle = clock * 2 * pi;
#switch(clock02)
#range(0,2)
#local shadow_x=-0.1-1.4*clock02/2;
#local shadow_y=2.75;
#local shadow_z=-5;
#break
#range(2,4)
#local shadow_x=-1.5+0.7*(clock02-2)/2;
#local shadow_y=2.75;
#local shadow_z=-5+(clock02-2)/2;
#break
#range(4,6)
#local shadow_x=-0.8-1.2*(clock02-4)/2;
#local shadow_y=2.75+0.25*(clock02-4)/2;
#local shadow_z=-4-2*(clock02-4)/2;
#break
#end
//union {
	object {
	//	drawPrism(scythe_outline_1,0,0.01)
	//	translate <0,-1.3,0>
	//	//rotate <0,0,sin(cycle) * 10>
	//	translate <0,0,0>
	//}
	drawPrism(interpolateShape(death_outline_1,death_outline_2,sin(cycle / 2)),0,1)
	//translate <0,cos(cycle) * 0.2,0>
	//translate <8.2 - clock_room * 4.5,0,0>
	scale <0.1,.15,.1>
	translate <shadow_x,shadow_y,shadow_z>
	pigment{rgbft<0,0,0,0,.7>}
} 
*/




//// bat  //////////////////////////////////////

/*#declare bat_x=-0.5;

#declare bat_move3= spline{
                        cubic_spline
    
                       -0.2,   <-1.3+bat_x, 2.1, 3.1>,
                        0.0,   <-1.4+bat_x, 2.0, 4.0>,
                        0.1,   <-1.5+bat_x, 1.9, 3.6>,
                        0.25,  <-1.7+bat_x, 1.7, 3.1>,
                        0.3,   <-1.5+bat_x, 1.8, 2.9>,
                        0.4,   <-1.6+bat_x, 1.7, 2.3>,
                        0.55,  <-1.4+bat_x, 1.6, 2.0>,
                        0.6,   <-1.6+bat_x, 1.4, 1.5>,
                        0.7,   <-1.7+bat_x, 1.6, 1.3>,
                        0.85,  <-1.9+bat_x, 1.4, 1.2>,
                        0.9,   <-1.7+bat_x, 1.3, 1.3>,
                        1.0,   <-1.9+bat_x, 3.0, 3.0>,
                        1.1,   <-2.0+bat_x, 3.1, 3.1>
                        }
  

#declare bat_color=rgb 1;
#declare bat_time=clock02;
#include "scenes/room/bat.inc"

object {bat scale 0.01 Spline_Trans(bat_move3,(bat_time/8), y, 0.01, 0.05) pigment{rgb bat_color}}*/

/*#declare tt=0;
#while (tt<1)
sphere{<0,0,0>, 0.03 Spline_Trans(bat_move3,tt, y, 0.1, 0) translate x*0 pigment {Red}}

#declare tt=tt+0.005;
#end*/

///////////////////////////////////////////////////